diff --git a/eit.c b/eit.c
index 0d685c5e..690c405b 100644
--- a/eit.c
+++ b/eit.c
@@ -115,22 +115,23 @@ cEIT::cEIT(cEitTablesHash &EitTablesHash, int Source, u_char Tid, const u_char *
      return;
      }
 
-  if (!EpgHandlers.BeginSegmentTransfer(Channel)) {
+  cSchedule *pSchedule = (cSchedule *)Schedules->GetSchedule(Channel, true);
+
+  if (pSchedule->OnActualTp(Tid) && (Tid & 0xF0) == 0x60) {
      SchedulesStateKey.Remove(false);
      ChannelsStateKey.Remove(false);
      return;
      }
 
-  bool ChannelsModified = false;
-  bool handledExternally = EpgHandlers.HandledExternally(Channel);
-  cSchedule *pSchedule = (cSchedule *)Schedules->GetSchedule(Channel, true);
-
-  if (pSchedule->OnActualTp(Tid) && (Tid & 0xF0) == 0x60) {
+  if (!EpgHandlers.BeginSegmentTransfer(Channel)) {
      SchedulesStateKey.Remove(false);
      ChannelsStateKey.Remove(false);
      return;
      }
 
+  bool ChannelsModified = false;
+  bool handledExternally = EpgHandlers.HandledExternally(Channel);
+
   bool Empty = true;
   bool Modified = false;
   time_t LingerLimit = Now - EPG_LINGER_TIME;
